# License

## Main Source Code
(contents of [app/](https://github.com/sonic-pi-net/sonic-pi/tree/stable/app) directory)

The MIT License (MIT)

Copyright (c) 2012 - 2022 Samuel Aaron and contributors (sam@sonic-pi.net)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.


## GPL Compliance
As Sonic Pi links with and contains GPLv3-licensed software, distributors of
Sonic Pi GUI binaries must comply with the terms of the GPL.


## Samples
(contents of [etc/samples/](https://github.com/sonic-pi-net/sonic-pi/tree/stable/etc/samples))

All the bundled samples are individually licensed under a
[CC0 1.0 Universal Public Domain Dedication](http://creativecommons.org/publicdomain/zero/1.0/). They
have all been obtained from [freesound.org](http://freesound.org) and
links to their sources can be found in the file
[etc/samples/README.md](https://github.com/sonic-pi-net/sonic-pi/blob/main/etc/samples/README.md)

[http://creativecommons.org/publicdomain/zero/1.0/](http://creativecommons.org/publicdomain/zero/1.0/)


## Wavetables
(contents of [etc/wavetables/](https://github.com/sonic-pi-net/sonic-pi/tree/stable/etc/wavetables)

All the bundled wavetable samples are individually licensed under a
[CC0 1.0 Universal Public Domain Dedication](http://creativecommons.org/publicdomain/zero/1.0/). They
have been obtained from the
[Adventure Kid](http://www.adventurekid.se/akrt/waveforms/adventure-kid-waveforms/)
site.


## Font
The font used in the GUI is [Hack](http://sourcefoundry.org/hack/) released under the [Hack Open Font License v2.0](https://github.com/chrissimpkins/Hack/blob/master/LICENSE.md)


## Docs, Tutorial and Examples
(contents of [etc/doc/](https://github.com/sonic-pi-net/sonic-pi/tree/stable/etc/doc) and [etc/examples](https://github.com/sonic-pi-net/sonic-pi/tree/stable/etc/examples) directories)

All the examples (in
[etc/examples](https://github.com/sonic-pi-net/sonic-pi/tree/stable/etc/examples))
and contents of the doc directory including the articles and the
tutorial are copyright by Sam Aaron unless a specific author is stated
with the comment `# coded by ...` in which case the copyright is
associated with that author (2015) and the content is released under the
CC BY-SA 4.0 license:

[http://creativecommons.org/licenses/by-sa/4.0/](http://creativecommons.org/licenses/by-sa/4.0/)


## Synth Designs
(contents of [etc/synthdefs/](https://github.com/sonic-pi-net/sonic-pi/tree/stable/etc/synthdefs) directory)

The bundled synth designs (synthdefs) are licensed under the [MIT License](http://opensource.org/licenses/MIT) with the following exceptions, which are licensed under the [GNU General Public License v3](https://www.gnu.org/licenses/gpl-3.0.html):

* [etc/synthdefs/designs/supercollider/bass_foundation.scd](https://github.com/sonic-pi-net/sonic-pi/tree/stable/etc/synthdefs/designs/supercollider/bass_foundation.scd)
* [etc/synthdefs/designs/supercollider/bass_highend.scd](https://github.com/sonic-pi-net/sonic-pi/tree/stable/etc/synthdefs/designs/supercollider/bass_highend.scd)
* [etc/synthdefs/designs/supercollider/winwood_lead.scd](https://github.com/sonic-pi-net/sonic-pi/tree/stable/etc/synthdefs/designs/supercollider/winwood_lead.scd)
* [etc/synthdefs/designs/supercollider/organ_tonewheel.scd](https://github.com/sonic-pi-net/sonic-pi/tree/stable/etc/synthdefs/designs/supercollider/organ_tonewheel.scd)

See their source files for links to the original designs.


## Bundled Software
The following is a list of the software included in Sonic Pi with their
relevant licenses:


### Unlinked software
* [Ruby](http://ruby-lang.org) - [Ruby License](https://www.ruby-lang.org/en/about/license.txt)
* [SuperCollider](http://supercollider.sourceforge.net) - [GNU General Public License v3](https://www.gnu.org/licenses/gpl-3.0.html)
* [Erlang](http://erlang.org) - [Erlang Public License](https://www.erlang.org/EPLICENSE)
* [Elixir](http://elixir-lang.org/) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [Aubio](http://aubio.org) - [GNU General Public License v3](https://www.gnu.org/licenses/gpl-3.0.html)
* [esbuild](https://esbuild.github.io/) - [MIT License](http://opensource.org/licenses/MIT)
* [tailwind](https://tailwindcss.com/) - [MIT License](http://opensource.org/licenses/MIT)


### Dynamically Linked Libraries for GUI
* [Qt](http://qt-project.org) - [GNU Lesser General Public License v2.1](https://www.gnu.org/licenses/lgpl-2.1.html)
* [QScintilla2](http://www.riverbankcomputing.com/software/qscintilla/intro) - [GNU General Public License v2](https://www.gnu.org/licenses/gpl-2.0.html)
* [KISS FFT](https://github.com/mborgerding/kissfft) - [BSD 3-Clause License](http://opensource.org/licenses/BSD-3-Clause)
* [Tracy](https://bitbucket.org/wolfpld/tracy/src/master/) - [BSD 3-Clause License](http://opensource.org/licenses/BSD-3-Clause)
* [ghc_filesystem](https://github.com/gulrak/filesystem) - [MIT License](http://opensource.org/licenses/MIT)
* [kissnet](https://github.com/Ybalrid/kissnet) - [MIT License](http://opensource.org/licenses/MIT)
* [liblo](https://github.com/radarsat1/liblo) - [GNU Lesser General Public License v2.1](https://www.gnu.org/licenses/lgpl-2.1.html)
* [boost (subset used by SuperCollider's scsynth)](https://www.boost.org) - [Boost Software License 1.0 (BSL-1.0)](https://opensource.org/licenses/BSL-1.0)
* [TLSF](http://www.gii.upv.es/tlsf/) - [GNU Lesser General Public License v2.1](https://www.gnu.org/licenses/lgpl-2.1.html)


### Dynamically Linked Libraries for Aubio 
* [ogg](https://github.com/xiph/ogg) - [BSD 3-Clause License](http://opensource.org/licenses/BSD-3-Clause)
* [opus](https://github.com/xiph/opus) - [BSD 3-Clause License](http://opensource.org/licenses/BSD-3-Clause)
* [flac](https://github.com/xiph/flac) - [GNU Lesser General Public License v2.1](https://www.gnu.org/licenses/lgpl-2.1.html)
* [vorbis](https://github.com/xiph/vorbis) - [BSD 3-Clause License](http://opensource.org/licenses/BSD-3-Clause)
* [libsndfile](http://www.mega-nerd.com/libsndfile/) - [GNU Lesser General Public License v2.1](https://www.gnu.org/licenses/lgpl-2.1.html)


### Included Ruby Libraries for Spider Language Server
(contents of [app/server/ruby/vendor/](https://github.com/sonic-pi-net/sonic-pi/tree/stable/app/server/ruby/vendor))

* [ActiveSupport](https://github.com/rails/rails/tree/master/activesupport) - [MIT License](http://opensource.org/licenses/MIT)
* [AST](https://github.com/whitequark/ast) - [MIT License](http://opensource.org/licenses/MIT)
* [Atomic](http://github.com/headius/ruby-atomic) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [Benchmark-IPS](https://github.com/evanphx/benchmark-ips) - [MIT License](http://opensource.org/licenses/MIT)
* [Blankslate](https://github.com/masover/blankslate) - [MIT License](http://opensource.org/licensesMIT)
* [FFI](https://github.com/ffi/ffi) - [BSD 3-Clause License](http://opensource.org/licenses/BSD-3-Clause)
* [i81n](https://github.com/svenfuchs/i18n) - [MIT License](http://opensource.org/licenses/MIT)
* [Interception](https://github.com/ConradIrwin/interception) - [MIT License](http://opensource.org/licenses/MIT)
* [Kramdown](http://kramdown.gettalong.org) - [MIT License](http://opensource.org/licenses/MIT)
* [Locale](https://github.com/ruby-gettext/locale) - [Ruby License](https://www.ruby-lang.org/en/about/license.txt)
* [Memoist](https://github.com/matthewrudy/memoist) - [MIT License](http://opensource.org/licenses/MIT)
* [Metaclass](https://github.com/floehopper/metaclass) - [MIT License](http://opensource.org/licenses/MIT)
* [MiniTest](http://ruby-doc.org/stdlib-2.0.0/libdoc/minitest/rdoc/MiniTest.html) - [Ruby License](https://www.ruby-lang.org/en/about/license.txt)
* [Mocha](http://gofreerange.com/mocha/docs/) - [MIT License](http://opensource.org/licenses/MIT)
* [Multi JSON](https://github.com/intridea/multi_json) - [MIT License](http://opensource.org/licenses/MIT)
* [NArray](https://github.com/masa16/narray) - [Ruby License](https://www.ruby-lang.org/en/about/license.txt)
* [Polyglot](http://github.com/cjheath/polyglot) - [MIT License](http://opensource.org/licenses/MIT)
* [Rouge](https://github.com/jneen/rouge) - [MIT License](http://opensource.org/licenses/MIT)
* [Ruby Beautify](https://github.com/erniebrodeur/ruby-beautify) - [MIT License](http://opensource.org/licenses/MIT)
* [Ruby CoreAudio](https://github.com/nagachika/ruby-coreaudio) - [MIT License](http://opensource.org/licenses/MIT)
* [Ruby Prof](https://github.com/ruby-prof/ruby-prof) - [BSD 2-Clause License](http://opensource.org/licenses/BSD-2-Clause) - [MIT License](http://opensource.org/licenses/MIT)
* [Rugged](https://github.com/libgit2/rugged) - [MIT License](http://opensource.org/licenses/MIT)
* [Sys Proctable](https://github.com/djberg96/sys-proctable) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [Text](https://github.com/threedaymonk/text) - [MIT License](http://opensource.org/licenses/MIT)
* [Thread Safe](https://github.com/ruby-concurrency/thread_safe) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [Tomlrb](https://github.com/fbernier/tomlrb) - [MIT License](http://opensource.org/licenses/MIT)
* [Treetop](https://github.com/cjheath/treetop) - [MIT License](http://opensource.org/licenses/MIT)
* [WaveFile](https://github.com/jstrait/wavefile/) - [MIT License](http://opensource.org/licenses/MIT)
* [Websocket Ruby](https://github.com/imanel/websocket-ruby) - [MIT License](http://opensource.org/licenses/MIT)


### Dynamically Linked Libraries for Tau IO Server NIFs
* [sp_midi](https://github.com/sonic-pi-net/sp_midi) - [MIT License](http://opensource.org/licenses/MIT)
* [sp_link](https://github.com/sonic-pi-net/sp_link) - [MIT License](http://opensource.org/licenses/MIT)
* [Ableton Link](https://github.com/Ableton/link) - [GNU General Public License v2](https://www.gnu.org/licenses/gpl-2.0.html)
* [RtMidi](https://github.com/thestk/rtmidi) - [MIT License + sharing request](https://github.com/thestk/rtmidi/blob/master/LICENSE)


### Included Elixir Libraries for Tau IO Server
(contents of app/server/beam/tau/deps/):

* [castore](https://github.com/elixir-mint/castore) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [cowboy](https://github.com/ninenines/cowboy) - [ISC License](https://opensource.org/licenses/ISC)
* [cowboy_telemetry](https://github.com/beam-telemetry/cowboy_telemetry) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [cowlib](https://github.com/ninenines/cowlib) - [ISC License](https://opensource.org/licenses/ISC)
* [decimal](https://github.com/ericmj/decimal) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [ecto](https://github.com/elixir-ecto/ecto) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [eflambe](https://github.com/Stratus3D/eflambe/) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [esbuild](https://github.com/phoenixframework/esbuild) - [MIT License](http://opensource.org/licenses/MIT)
* [exsync](https://github.com/falood/exsync) - [BSD 3-Clause License](http://opensource.org/licenses/BSD-3-Clause)
* [file_system](https://github.com/falood/file_system) - [WTFPL](http://www.wtfpl.net/)
* [flame_on](https://github.com/DockYard/flame_on) - [MIT License](http://opensource.org/licenses/MIT)
* [floki](https://github.com/philss/floki) - [MIT License](http://opensource.org/licenses/MIT)
* [gettext](https://github.com/elixir-gettext/gettext) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [html_entities](https://github.com/martinsvalin/html_entities) - [MIT License](http://opensource.org/licenses/MIT)
* [jason](https://github.com/michalmuskala/jason) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [logger_file_backend](https://github.com/onkel-dirtus/logger_file_backend) - [MIT License](http://opensource.org/licenses/MIT)
* [meck](https://github.com/eproxus/meck) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [mime](https://github.com/elixir-plug/mime) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [petal_components](https://github.com/petalframework/petal_components) - [MIT License](http://opensource.org/licenses/MIT)
* [phoenix](https://github.com/phoenixframework/phoenix) - [MIT License](http://opensource.org/licenses/MIT)
* [phoenix_ecto](https://github.com/phoenixframework/phoenix_ecto) - [MIT License](http://opensource.org/licenses/MIT)
* [phoenix_html](https://github.com/phoenixframework/phoenix_html) - [MIT License](http://opensource.org/licenses/MIT)
* [phoenix_live_dashboard](https://github.com/phoenixframework/phoenix_live_dashboard) - [MIT License](http://opensource.org/licenses/MIT)
* [phoenix_live_reload](https://github.com/phoenixframework/phoenix_live_reload) - [MIT License](http://opensource.org/licenses/MIT)
* [phoenix_live_view](https://github.com/phoenixframework/phoenix_live_view) - [MIT License](http://opensource.org/licenses/MIT)
* [phoenix_pubsub](https://github.com/phoenixframework/phoenix_pubsub) - [MIT License](http://opensource.org/licenses/MIT)
* [phoenix_view](https://github.com/phoenixframework/phoenix_view) - [MIT License](http://opensource.org/licenses/MIT)
* [plug](https://github.com/elixir-plug/plug) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [plug_cowboy](https://github.com/elixir-plug/plug_cowboy) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [plug_crypto](https://github.com/elixir-plug/plug_crypto) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [ranch](https://github.com/ninenines/ranch) - [ISC License](https://opensource.org/licenses/ISC)
* [rustler](https://github.com/rusterlium/rustler) - [MIT License](http://opensource.org/licenses/MIT)
* [tailwind](https://github.com/phoenixframework/tailwind) - [MIT License](http://opensource.org/licenses/MIT)
* [telemetry](https://github.com/beam-telemetry/telemetry) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [telemetry_metrics](https://github.com/beam-telemetry/telemetry_metrics) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [telemetry_poller](https://github.com/beam-telemetry/telemetry_poller) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
* [toml](https://github.com/bitwalker/toml-elixir) - [Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)


### Included Javascript Libraries for Tau IO Server 
(contents of [app/server/beam/tau/assets/vendor/](https://github.com/sonic-pi-net/sonic-pi/tree/stable/app/server/beam/tau/assets/vendor)):

* [Alpine.js](https://github.com/alpinejs/alpine) - [MIT License](http://opensource.org/licenses/MIT)
* [topbar](http://buunguyen.github.io/topbar) - [MIT License](http://opensource.org/licenses/MIT)
