# Types of contributions

Hello! Are you interested in contributing to Sonic Pi, but not sure where to start? there are many ways to do so, even besides writing code.
Here's a few ways you can help:

## Share your Sonic Pi experiences
- Sharing your Sonic Pi experiences with people is a great way to raise awareness of Sonic Pi. Giving talks, performances, tutorials or workshops, sharing resources and teaching materials, or even just posting a simple message on social media about it (on Twitter we're `@Sonic_Pi`) are all ways you can spread the word. For all the different ways people can connect as a community around Sonic Pi, see [COMMUNITY.md](COMMUNITY.md)

## Help with issues and pull requests on GitHub
- Proof-reading pull requests. If a pull request contains plain text besides code, then spelling and grammar checks are always helpful. The default language is British English (en-GB).
- Adding helpful comments to issues. [The list of issues on GitHub](https://github.com/sonic-pi-net/sonic-pi/issues) can often be quite large - this can become difficult for the core development team to manage, so comments that help to manage this are always welcome.
  This could include things like replying to folks:
  - Reminders that (politely) point to our [troubleshooting guide](https://github.com/sonic-pi-net/sonic-pi/wiki/Troubleshooting-Issues)
  - Help with filling out the issue templates
  - Pointers to existing issues that might already describe the same specific problem or request
  
  Or providing your own extra information to issues:
  - More detail to describe the problem
  - Potential workarounds or ideas for solutions

## Raise a feature request
If you have an idea for a new feature or enhancement, search the [Issues page](https://github.com/sonic-pi-net/sonic-pi/issues) or [the Sonic Pi features project board](https://github.com/orgs/sonic-pi-net/projects/1) first (someone might have raised it already!).
If it's new after all, go ahead and [raise a feature request](https://github.com/sonic-pi-net/sonic-pi/issues/new/choose)!

You can also visit [the Sonic Pi community forum](https://in-thread.sonic-pi.net/) if you want to discuss your idea more informally.

## Translate Sonic Pi to your language
It's a wonderful way to introduce school kids in your country to
Sonic Pi and educators will appreciate it when we make it easier for
their class. The tutorial is fairly long, but the graphical user
interface is quickly translated and a good place to start.
For details, see [TRANSLATION.md](TRANSLATION.md)

## Send us some changes for Sonic Pi in a Pull Request
We're always interested in receiving fixes, new features and improvements for Sonic Pi - even more so in areas that the core team has been unable to focus on!

If you don't have a specific bug-fix, new feature, or enhancement already in mind, you can always browse the
[open issues](https://github.com/sonic-pi-net/sonic-pi/issues) or [the Sonic Pi features project board](https://github.com/orgs/sonic-pi-net/projects/1) on GitHub.
There's probably an issue you can help to fix, or feature request you can help build.
For guidelines to keep in mind while you're preparing your contribution, see [CONTRIBUTING.md](CONTRIBUTING.md)
