2.2 Opcions de sintetitzador

# Opcions de sintetitzador: Amp i Pan

A banda de permetre-vos controlar quina nota tocar o quina mostra de so llançar, Sonic Pi compta amb una rang complet d'opcions per a polir i controlar els sons. En aquest tutorial cobrirem molts d'aquests assumptes; existeix una ampla documentació per cadascun d'ells al sistema d'ajuda. No obstant això, per ara n'introduirem dos dels més útils: *amplitude* i *pan*. Fem, primer, una ullada a les opcions que hi ha.


## Opcions

Sonic Pi admet la idea d'opcions (abreviant, opts) per als seus sintetitzadors. Les Opts són controls que s'afegeixen a `play`i que modifiquen i controlen aspectes del so. Cada sintetitzador té el seu propi conjunt d'opcions per ajustar amb precisió els seus sons. No obstant això, hi ha conjunts d'opcions en comú per a la majoria de sons, tals com `amp:` o altres opcions d'envolupant (cobertes en una altra secció).

Les opcions tenen dues parts principals: el nom (el nom del control) i el valor (el valor que voleu donar al control). Per exemple, podeu tindre una opció anomenada `cheese:` i que tinga un valor d'`1`.

Les opcions s'afegeixen a les ordres `play`afegint una coma `,`i seguidament el nom de l'opció, com per exemple `amp:`(no oblideu els dos punts `:`) i a continuació un espai i el valor per a l'opció en si. Per exemple:

```
play 50, cheese: 1
```

(Noteu que `cheese:`no és una opció vàlida, només l'hem fet servir com a exemple).

Podeu afegir diverses Opts, separades per comes:

```
play 50, cheese: 1, beans: 0.5
```

L'ordre de les Opts no importa, el següent serà igual a l'anterior:

```
play 50, beans: 0.5, cheese: 1
```

Les opcions que no són reconegudes pel sintetitzador seran simplement ignorades (com en el cas de `cheese` i `beans`, les quals tenen noms ridículs! (traducció: cheese -> formatge, beans -> fesols)

Si accidentalment utilitzeu el mateix opcions dues vegades amb valors diferents, l'últim és el que prevaldrà. Per exemple, `beans:` ací tindrà un valor de 2 i no de 0.5:

```
play 50, beans: 0.5, cheese: 3, eggs: 0.1, beans: 2
```

Moltes coses a Sonic Pi accepten opcions, només cal passar temps aprenent com utilitzar-les i ja estareu preparats! Juguem amb la primera opció: `amp:`.

## Amplitud

L'amplitud és una representació computeritzada del volum d'un so. Una *amplitud alta produeix un so de volum alt* i una *amplitud baixa produeix un so de volum baix*. De la mateixa manera que Sonic Pi utilitza números per representar tons i temps, també n'utilitza per representar l'amplitud. Una amplitud 0 és silenci (no escoltareu res) i una amplitud de 1 és volum normal. Fins i tot podeu augmentar l'amplitud fins a 2, 10 o 100. No obstant això, heu de tenir en compte que quan l'amplitud de tots els sons és molt alta, Sonic Pi utilitza un compressor per assegurar-se que no us feu mal a l'orella. Això pot fer que els sons esdevinguen bruts, estranys.  Intenteu utilitzar amplituds baixes, això és, en el rang entre 0 i 0.5 per tal d'evitar la compressió.


## Amplifiqueu-ho

Per canviar l'amplitud d'un so, feu servir l'opció `amp:`. Per exemple, per tocar a la meitat d'amplitud canvieu-ho a 0.5:

```
play 60, amp: 0.5
```

Per tocar-ho al doble d'amplitud, indiqueu 2:

```
play 60, amp: 2
```

L'opció `amp:` només modifica l'entrada `play` a la qual està associada. Així, en aquest exemple, la primera entrada `play` està a meitat volum i la segona torna al valor per defecte (1):

```
play 60, amp: 0.5
sleep 0.5
play 65
```

Per descomptat, podeu utilitzar diferents valors d'`amp:`per a cada ordre de `play`:

```
play 50, amp: 0.1
sleep 0.25
play 55, amp: 0.2
sleep 0.25
play 57, amp: 0.4
sleep 0.25
play 62, amp: 1
```

## Panoramització

Un altra opció divertida d'utilitzar és `pan:`, que controla la panoramització d'un so en estèreo. Panoramitzar un so a l'esquerra significa que l'escoltareu a l'altaveu esquerre, i panoramitzar-lo a la dreta vol dir que l'escoltareu a l'altaveu dret. Per als nostres valors, utilitzarem -1 per representar completament a l'esquerra, 0 per represetar el centre i 1 per representar completament a la dreta. Per descomptat, podeu fer servir qualsevol valor entre mig de -1 i 1 per controlar la posició exacta del so.

Toquem un so des de l'altaveu esquerre:

```
play 60, pan: -1
```

Ara, feu que sone per l'altaveu dret:

```
play 60, pan: 1
```

Finalment, fem que sone novament al centre (posició per defecte):

```
play 60, pan: 0
```

Ara, xaleu canviant l'amplitud i la panoramització dels sons!
