2.3 Skift af synths

# Skift af synths

Indtil videre har vi moret os vældigt med at lave biplyde, men det kan være at du er ved at kede dig lidt over den simple lyd. Er det virkelig alt hvad Sonic Pi kan? Er der mon ikke andet i live-kodning end blot at spille biplyde? Jo da, og i dette kapitel vil vi udforske nogle af de spændende muligheder for forskellige lyde som Sonic Pi tilbyder.

## Synths

Sonic Pi har en masse forskellige instrumenter som vi kalder synths. Det er en forkortelse for *synthesisers*. I modsætning til samples, som er lydklip der er optaget på forhånd, kan synths generere nye lyde afhængigt af hvordan du styrer dem - det vil vi komme nærmere ind på senere i denne vejledning. De synths som Sonic Pi tilbyder, er meget udtryksfulde, og du vil få meget sjov ud af at udforske og lege med dem. Lad os først få lært hvordan man vælger en synth.

## Brummende save og profeter

En sjov lyd er *sav-bølgen* - lad os prøve den:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
play 62
```

Lad os prøve en anden lyd - *profeten*:

```
use_synth :prophet
play 38
sleep 0.25
play 50
sleep 0.25
play 62
```

Hvad med en kombination af de to lyde? Først den ene efter den anden:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
use_synth :prophet
play 57
```

Nu flere lyde på samme tid - det opnår vi ved ikke at kalde `sleep` mellem kaldene til `play`:

```
use_synth :tb303
play 38
use_synth :dsaw
play 50
use_synth :prophet
play 57
```

Bemærk at kommandoen `use_synth` kun påvirker de efterfølgende kald til `play`. Betragt det som en *stor pegepind* - nye kald til `play` vil spille en hvilken som helst synth som den peger på nu. Du kan bagefter pege på en ny synth med `use_synth`.


## Udforskning af synths

For at se hvilke synths Sonic Pi giver dig at lege med, kan du tage et kig i Synths-fanen i menuen nederst i denne hjælpeskærm (mellem Examples og Fx). Der er over 20 at vælge imellem. Her er nogle af mine yndlings-synths:

* `:prophet`
* `:dsaw`
* `:fm`
* `:tb303`
* `:pulse`

Prøv nu at *skifte synths undervejs i din musik*. Leg med at kombinere synths for at lave nye lyde, og prøv at bruge forskellige synths til forskellige dele af din musik.
