1.2 Découverte de l'interface

# L'Interface de Sonic Pi

Sonic Pi a une interface très simple pour coder de la musique. Passons un peu de temps à l'explorer.

![Interface de Sonic Pi](../../../etc/doc/images/tutorial/GUI.png)


* *A* - Contrôles de jeu
* *B* - Contrôles d'édition
* *C* - Info et aide
* *D* - Éditeur de code
* *E* - Panneau des préférences
* *F* - Visualisateur de la trace
* *G* - Système d'aide
* *H* - Visualisateur de la portée
* *F* - Visualiseur des Signaux (Cue)

## A. Contrôles de jeu

Ces boutons roses sont les principaux contrôles pour démarrer et arrêter les sons. Il y a le bouton *Run* pour exécuter le code présent dans l'éditeur, *Stop* pour arrêter tous les codes en cours d'exécution, *Save* pour sauvegarder le code dans un fichier externe et *Record* pour créer un enregistrement du son (un fichier WAV) en cours de jeu.

## B. Contrôles d'édition

Ces boutons orange vous permettent de manipuler l'éditeur de code. Les boutons *Taille +* et *Taille -* vous permettent de rendre le texte plus grand et plus petit.

## C. Info et Aide

Ces boutons bleus vous donnent accès à l'information, à l'aide et aux préférences. Le bouton *Info* ouvre la fenêtre d'information qui contient de l'information sur Sonic Pi lui-même - le noyau de l'équipe, l'historique, les contributeurs, et la communauté. Le bouton *Aide* active le système d'aide (*G*) et le bouton *Prefs* active la fenêtre des préférences qui vous permet de contrôler quelques paramètres systèmes basiques.

## D. Éditeur de code

C'est la zone dans laquelle vous écrirez votre code et composerez / interpréterez de la musique. C'est un simple éditeur de texte où vous pourrez écrire votre code, l'effacer, couper et coller, etc. Voyez-le comme une version très basique de Word ou de Google Docs. L'éditeur coloriera automatiquement les mots selon leur signification dans le code. Ceci peut paraître étrange au début, mais vous trouverez vite cela très utile. Par exemple, vous saurez que quelque chose est un nombre parce qu'il sera bleu.

## E. Panneau des préférences

Sonic Pi supporte quelques préférences ajustables auxquelles on peut accéder en pressant le bouton *Prefs* à droite des boutons Info et Help. Cela activera l'affichage du panneau des préférences qui inclut un nombre d'options modifiables. Par exemple pour forcer le mode mono, inverser la stéréo, activer le mode verbeux de la trace et aussi régler un curseur de volume et le sélecteur audio du Raspberry Pi.

## F. Visualisateur de la trace

Quand vous exécutez votre code, l'information sur ce que le programme est en train de faire est affichée dans le visualiseur de la trace. Par défaut, vous verrez un message pour chaque son que vous créez avec l'heure exacte à laquelle le son a été déclenché. C'est très utile pour déboguer votre code et comprendre ce qu'il fait.

## G. Système d'aide

Enfin, un des aspects les plus importants de l'interface de Sonic Pi est le système d'aide qui apparaît au bas de la fenêtre. Il peut être activé ou désactivé en cliquant sur le bouton *Help* bleu. Le système d'aide contient de l'aide et de l'information sur tous les aspects de Sonic Pi, y compris ce tutoriel, une liste des synthétiseurs, des échantillons ("samples"), des exemples, des effets ("FX") disponibles, et une liste complète de toutes les fonctions que Sonic Pi fournit pour coder de la musique.

## H. Visualiseur de la portée

Le visualiseur d'oscillo vous permet de voir le son que vous entendez. Vous pouvez facilement voir que l'onde en dent de scie ressemble à une scie et que le bip basique est une onde sinusoïdale courbe. Vous pouvez voir aussi la différence entre les sons forts et légers à la taille des lignes. Il y a 3 oscilloscopes avec lesquels jouer - celui par défaut est un oscilloscope combiné pour les canaux gauche et droit, il y a un oscilloscope stéréo qui affiche un graphique différent pour chaque canal. Enfin, il y a l'oscilloscope Lissajous qui montre la relation de phase entre les canaux gauche et droit et vous permet de faire de jolis dessins avec du son (https://en.wikipedia.org/wiki/Lissajous_curve).

## I. Visualiseur de signal (cue)

Tous les événements internes et externes (appelés cues dans Sonic Pi) sont automatiquement enregistrés dans le Cue Viewer. Par exemple, si vous avez un contrôleur MIDI connecté et que vous appuyez sur l'un de ses boutons, vous verrez un nouvel événement dans le Cue Viewer vous indiquant le nom du contrôleur et le bouton sur lequel vous avez appuyé. Une fois que vous aurez maîtrisé les bases de la création et de la production de sons, vous commencerez à vouloir marquer des sons ou des sections entières de sons en fonction d'événements tels que ceux-ci. Un signal sonore n'est qu'une indication que quelque chose s'est produit. Par exemple, chaque fois qu'une boucle en direct tourne, elle envoie un signal qui est enregistré dans le Cue Viewer. De plus, des événements externes tels que des messages MIDI provenant d'un équipement MIDI connecté et des messages OSC provenant d'autres programmes ou ordinateurs sont également affichés dans le Cue Viewer. Il est également possible de générer directement des événements de cue en utilisant la fonction "rescue". Tout ce qui apparaît dans le Cue Viewer peut être utilisé pour déclencher un événement. Ce point est traité plus en détail dans les sections 10 à 12 de ce tutoriel.
