2.3 Changement de synthés

# Changement de synthés

Jusqu'à maintenant, nous nous sommes bien amusés à faire des beeps. Cependant, vous commencez probablement à être fatigué par le bruit basique du beep. Sonic Pi ne peut pas m'en offrir plus ? Il y a certainement plus dans le codage en "live" que de jouer seulement des beeps ? Oui, et dans cette section, nous allons explorer l'étendue des sons que Sonic Pi vous propose.

## Synthétiseurs

Sonic Pi dispose d'instruments appelés synthés (*raccourci pour synthétiseurs*). Tandis que les échantillons (samples) représentent des sons pré-enregistrés, les synthés (synths) sont capables de générer des nouveaux sons en fonction de la façon dont vous les contrôlez (ce que nous explorerons plus tard dans ce tutoriel). Les synthés de Sonic Pi sont très puissants et expressifs, et vous prendrez du plaisir à les explorer et jouer avec. Avant tout, apprenons à sélectionner le synthé qui sera utilisé.

## Dents de scie vibrantes et prophètes

Un son sympathique est l'*onde en dent de scie (saw)*. Essayons-le :

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
play 62
```

Essayons un autre son, le *prophet* :

```
use_synth :prophet
play 38
sleep 0.25
play 50
sleep 0.25
play 62
```

Et si on combinait deux sons ? D'abord l'un après l'autre :

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
use_synth :prophet
play 57
```

Maintenant plusieurs sons en même temps (en ne mettant pas d'instructions `sleep` entre les `play` successifs) :

```
use_synth :tb303
play 38
sleep 0.25
use_synth :dsaw
play 50
sleep 0.25
use_synth :prophet
play 57
```

Notez que la commande `use_synth` n'agit que sur les appels suivants à `play`. Pensez à elle comme un *gros commutateur* : les nouveaux appels à `play` vont jouer tout synthé qui est désigné "en cours". Vous pouvez enclencher le commutateur sur un nouveau synthé avec `use_synth`.


## Découverte des synthés

Pour lister les synthés que Sonic Pi propose, jetez un œil sur les options de Synths dans le menu horizontal tout à fait en bas (à gauche de Fx). Il y en a plus de 20 au choix. Voici mes préférés :

* `:prophet`
* `:dsaw`
* `:fm`
* `:tb303`
* `:pulse`

Maintenant jouez en *commutant les synthés au cours de votre jeu*. Prenez plaisir à combiner des synthés pour faire de nouveaux sons et aussi en utilisant différents synthés selon les sections de votre musique.
