2.2 Valkostir gervla

# Valkostir gervla: Amp og Pan

Í Sonic Pi færðu ekki bara að stjórna hvaða nótur eða sýni þú spilar, heldur eru margir valkostir sem þú getur notað til að móta og stjórna hljóðunum. Við eigum eftir að fara yfir marga þeirra í þessari kennslu og svo er fullt af upplýsingum um hvern þeirra í hjálparkerfinu. En hér ætlum við að taka fyrir tvo af allra gagnlegustu valkostunum: *sveifluvídd* (amplitude) og *pan*. En kíkjum fyrst á hvað er átt við með *valkostum*.


## Valkostir

Sonic Pi styður hugmyndina um valkosti eða kosti (options, opts). Kostir eru stillingar sem þú setur í `play` og sem breyta og stjórna einhverjum eiginleika hljóðsins sem þú heyrir. Hver gervill er með eigið sett af kostum til að fínstilla hljóðið sem hann gefur. En það eru til kostir sem eru sameiginlegir mörgum hljóðum, t.d. `amp:` svo og kostir hjúps (envelope), sem við tölum um síðar.

Kostir hafa tvo aðalhluta, heiti og gildi. Þú gætir t.d. haft kost sem heitir `cheese:` og gætir viljað gefa honum gildið `1`.

Þegar kostir eru settir í `play` eru þeir aðskildir með kommu `,` og síðan kemur heiti kostsins, t.d. `amp:` (ekki gleyma tvípunktinum `:`) og síðan bil og svo gildið fyrir kostinn. Til dæmis:

```
play 50, cheese: 1
```

(Athugaðu að `cheese` er ekki raunverulegur kostur, heldur bara notað hér sem dæmi).

Þú getur sett marga kosti ef þú aðskilur þá með kommu:

```
play 50, cheese: 1, beans: 0.5
```

Röð kostanna skiptir ekki máli, þannig að eftirfarandi er jafngilt:

```
play 50, beans: 0.5, cheese: 1
```

Ef gervill þekkir ekki kost er hann bara hunsaður (eins og `cheese` og `beans` sem eru augljóslega fáránleg nöfn á kostum!)

Ef þú óvart notar sama kostinn tvisvar en með mismunandi gildum þá vinnur sá síðari. Til dæmis mun `beans:` hér hafa gildið 2 en ekki 0.5:

```
play 50, beans: 0.5, cheese: 3, eggs: 0.1, beans: 2
```

Það er margt í Sonic Pi sem notar kosti, svo það er þess virði að læra að nota þá og þá ertu í góðum málum! Prófum nú fyrsta alvöru kostinn: `amp:`.

## Sveifluvídd (amplitude)

Sveifluvídd vísar í aðferð tölvunnar til að sýna styrk hljóðs eða hve mikið hljóðbylgjan sveiflast. *Mikil sveifluvídd gefur sterkt hljóð* og *lítil sveifluvídd gefur veikt hljóð*. Alveg eins og með tíma og nótur, þá notar Sonic Pi tölur til að tákna sveifluvídd. Sveifluvíddin 0 er þögn (þú heyrir ekkert!) en sveifluvídd 1 er venjulegur hljóðstyrkur. Þú getur stillt sveifluvíddina á 2, 10 eða 100. En þú skalt athuga að ef heildar sveifluvídd allra hljóðanna verður of mikil þá notar Sonic Pi svonefnda pressu (compressor) til að bæla þau til að tryggja að hljóðin verði ekki of há fyrir eyru þín. Þetta verður oft til að hljóðin virka undarlega bæld og óskýr. Þú ættir því að nota lága sveifuvídd, þ.e. á bilinu 0 til 0.5 til að forðast pressuna.


## Ampaðu þetta

Til að breyta sveifluvídd hljóðs getur þú notað kostinn `amp:` Í þessu dæmi er spilað með hálfri sveifluvídd 0.5:

```
play 60, amp: 0.5
```

Til að spila með tvöfaldri sveifluvídd fær amp gildið 2:

```
play 60, amp: 2
```

Kosturinn `amp` breytir aðeins þeirri `play` skipun sem það tengist. Þannig að í þessu dæmi spilar fyrri `play` skipunin með hálfum hljóðstyrk en seinni `play` skipunin notar sjálfgefna gildið (1):

```
play 60, amp: 0.5
sleep 0.5
play 65
```

Auðvitað getur þú notað mismunandi `amp` gildi fyrir hverja `play` skipun:

```
play 50, amp: 0.1
sleep 0.25
play 55, amp: 0.2
sleep 0.25
play 57, amp: 0.4
sleep 0.25
play 62, amp: 1
```

## Pönun

Annar góður kostur er `pan:` sem snýst um að pana (pan) hljóð í víðómi. Að pana hljóð til vinstri þýðir að þú heyrir það út um vinstri hátalarann, og ef það er panað til hægri þá heyrist það út um hægri hátalarann. Sem gildi notum við -1 til að tákna alveg til vinstri, 0 til að tákna fyrir miðju og 1 til að tákna að fullu til hægri í víðómssviðinu. Og auðvitað getum við notað hvaða tölu sem er á milli -1 og 1 til að stjórna nákvæmlega hvaðan hljóð berst.

Prófum að spila píp út um vinstri hátalarann:

```
play 60, pan: -1
```

Og núna út um hægri hátalarann:

```
play 60, pan: 1
```

Loks skulum við spila það út frá miðjunni (sem er sjálfgefna gildið):

```
play 60, pan: 0
```

Leiktu þér nú með að breyta sveifluvídd (hljóðstyrk) og pana hljóð!
