2.3 Muoversi fra i Synth

# Muoversi fra i Synth

Finora ci siamo divertiti un sacco con i beep. Ma probabilmente questi semplici beep staranno cominciando ad annoiarti. È tutto qui quello che Sonic Pi ha da offrire? Ci sarà qualcosa di più nel live coding che suonare dei beep! Certo che c’è, e in questa sezione esploriamo la vasta gamma di suoni che offre Sonic Pi.

## Synth (Sintetizzatori)

Sonic Pi offre una ampia gamma di strumenti chiamati synth, forma abbreviata per *sintetizzatori*. Mentre i sample contengono suoni pre-registrati, i synth sono in grado di generare nuovi suoni in base a come li controlli (cosa che esploreremo più in là nel tutorial). I synth di Sonic Pi sono molto potenti ed espressivi e ti divertirai molto nell’esplorarne le possibilità e nel suonarli. Per prima cosa, impariamo a selezionare il synth da suonare.

## Onde a dente di sega e prophets

Un suono divertente è il *dente di sega*. Proviamolo:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
play 62
```

Adesso proviamo un altro suono - il *prophet*:

```
use_synth :prophet
play 38
sleep 0.25
play 50
sleep 0.25
play 62
```

E se combinassimo insieme due suoni? Prima uno, poi l’altro:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
use_synth :prophet
play 57
```

Ora riproduciamo più suoni contemporaneamente (non mettendo sleep tra chiamate successive di `play`):

```
use_synth :tb303
play 38
use_synth :dsaw
play 50
use_synth :prophet
play 57
```

Nota che il comando `use_synth` influenza soltanto le chiamate seguenti a `play`. Pensalo come un *grande switch* - le nuove chiamate a `play` useranno qualsiasi sintetizzatore sia in uso in quel momento. Puoi regolare lo switch su un nuovo synth con l’istruzione `use_synth`.


## Alla scoperta dei Synth

Per vedere quali sintetizzatori Sonic Pi mette a tua disposizione, dai un’occhiata all’opzione Synths nel menu in basso in questa schermata di aiuto (tra Esempi e FX). Ce ne sono più di 20 tra cui scegliere. Ecco qui sotto soltanto alcuni dei miei preferiti:

* `:prophet`
* `:dsaw`
* `:fm`
* `:tb303`
* `:pulse`

Ora divertiti a *cambiare i synth mentre fai la tua musica*. Divertiti a combinare i synth per fare nuovi suoni e ad usare synth differenti in diverse sezioni della tua musica.
