7.1 Controllare i sintetizzatori in riproduzione

# Controllare i sintetizzatori in riproduzione

Finora ci siamo preoccupati solo di lanciare nuovi suoni ed effetti. Ciononostante Sonic Pi ci dà la possibilità di manipolare e controllare tutti i suoni in riproduzione. Lo possiamo fare utilizzando una variabile:

```
s = play 60, release: 5
```

Qui abbiamo una variabile locale `s` che rappresenta il sintetizzatore che suona la nota 60. Nota bene: si tratta di una variabile *locale* che non può essere richiamata da altre funzioni.

Ora che abbiamo `s`, possiamo cominciare a controllarlo utilizzando la funzione `control`:

```
s = play 60, release: 5
sleep 0.5
control s, note: 65
sleep 0.5
control s, note: 67
sleep 3
control s, note: 72
```

Notiamo come non stiamo utilizzando 4 synth differenti, stiamo utilizzando un solo sintetizzatore cambiando il pitch della nota 3 volte mentre sta suonando.

Possiamo passare tutti i parametri standard attraverso `control`, per cui possiamo controllare cose come `amp:`, `cutoff:` oppure `pan:`.

## Parametri non controllabili

Alcuni parametri non possono essere modificati una volta che il synth è partito, per esempio l'inviluppo ADSR. Puoi scoprire quali parametri puoi modificare guardando nella documentazione. Se trovi scritto *non può essere modificato una volta impostato*, saprai che non puoi modificarlo una volta avviato il synth.
