A.16 W jaki sposób ćwiczyć kodowanie na żywo (Live Coding)

# 8 Wskazówek dotyczących ćwiczenia kodowania na żywo (Live Coding)

W ubiegłym miesiącu mieliśmy okazję poznać pięć ważnych technik, które umożliwiają opanowanie kodowania na żywo (Live Coding) - innymi słowy, dowiedzieliśmy się, w jaki sposób możemy wykorzystać Sonic Pi, aby zastosować do kodu takie same podejście jak do instrumentu muzycznego. Jedną z ważnych koncepcji, które omówiliśmy, była praktyka. W tym miesiącu posuniemy się dalej i głębiej, żeby zrozumieć, dlaczego praktykowanie kodowania na żywo jest takie ważne i w jaki sposób możesz zacząć.


## Ćwicz regularnie

Najważniejszą radą, jaką mogę Ci dać, to pilnowanie się, aby ćwiczyć regularnie. Z zasady zazwyczaj ćwiczę ok. 1-2 godzin dziennie, ale dla Ciebie na początek może wystarczyć i 20 minut dziennie. Mało, ale często jest to Twój cel - jeśli więc możesz wygospodarować choćby 10 min, to świetny początek.

Wskazówka #1 - spraw, aby ćwiczenie stało się Twoją rutyną. Znajdź w ciągu dnia dobry moment, który będzie Ci odpowiadał i postaraj się ćwiczyć w tym czasie tak wiele dni w tygodniu, jak tylko możesz. Już niedługo będziesz nie będziesz mógł się doczekać Twojej kolejnej regularnej sesji.


## Naucz się pisać bezwzrokowo na klawiaturze

Jeśli zdarzy Ci się oglądać profesjonalnego muzyka występującego na scenie, to na pewno zauważysz kilka rzeczy. Po pierwsze, kiedy grają, nie patrzą na swój instrument. Ich palce, ramiona i ciała wiedzą, które klawisze naciskać, które struny uderzać, w który bęben uderzyć bez nadmiernej konieczności myślenia o tym, jak to zrobić. Nazywa się to "pamięcią mięśniową" i mimo że może to brzmieć jak coś, co mogą robić tylko profesjonaliści - to jest z tym dokładnie tak samo jak wtedy, gdy nauczyłeś się chodzić czy jeździć na rowerze - ćwiczenie poprzez powtarzanie. Osoby kodujące na żywo (Live Coders) używają pamięci mięśniowej, aby zwolnić ich umysły z konieczności myślenia o tym, jak układać swoje palce, dzięki czemu mogą skupić się na muzyce. Nazywa się to pisaniem bezwzrokowym - pisaniem bez konieczności patrzenia na klawiaturę.

Wskazówka #2 - naucz się pisać bez patrzenia na klawiaturę. Istnieje wiele aplikacji, stron, a nawet gier, które pomogą Ci to osiągnąć. Znajdź jedną, która Ci się podoba i trzymaj się jej, dopóki nie będziesz umiał kodować bez konieczności opuszczania wzroku na klawiaturę.


## Koduj na stojąco

Ciało muzyka jest przystosowane do grania na swoim instrumencie. Na przykład osoba grająca na trąbce musi być zdolna do porządnego dmuchania, gitarzysta musi umieć złapać gryf z odpowiednią siłą, perkusista musi umieć nieprzerwanie uderzać w bębny przez długi kawałek czasu. A jakie zdolności fizyczne są niezbędne do kodowania na żywo? Dokładnie tak jak DJe, kodujący na żywo zazwyczaj występują na stojąco, a niektórzy nawet tańczą podczas kodowania! Jeśli zaczniesz ćwiczyć kodowanie, siedząc za biurkiem, a następnie będziesz zmuszony, żeby stać podczas imprezy, to na pewno od razu zauważysz różnicę i będzie to dla Ciebie trudne oraz frustrujące.

Wskazówka #3 - stój podczas swoich ćwiczeń. Najprostszą metodą jest użycie do tego wysoko stojącego biurka. Jednakże, jeśli tak jak ja nie posiadasz takiego w domu, jest kilka tańszych opcji. Używam do tego deski do prasowania, która sprawuje się tutaj całkiem nieźle. Inną metodą jest postawienie kilku pudełek lub dużych książek na normalnym biurku i umieszczenie na nich Twojej klawiatury. Pamiętaj tylko o tym, aby się dobrze porozciągać przed ćwiczeniami i spróbować trochę tańczyć podczas sesji. Pamiętaj - nikt nie patrzy, więc baw się, a sprawi to, że na scenie będziesz czuł się dużo bardziej komfortowo.


## Ćwicz konfigurację

Większość instrumentów wymaga przygotowania i nastrojenia, zanim będzie można na nich grać. O ile nie jesteś gwiazdą rocka z autobusem pełnym pomocników odpowiadających za sprzęt, to będziesz musiał samodzielnie skonfigurować i podłączyć swój instrument przed imprezą. Często jest to dość stresujący moment i bardzo łatwo wtedy o wystąpienie problemów. Najlepszą metodą na poradzenie sobie z tym jest włączenie procesu ustawiania i podłączania sprzętu do Twoich sesji.

Wskazówka #4 - traktuj ustawianie i podłączanie sprzętu jako bardzo ważną część Twoich ćwiczeń. Na przykład przygotuj sobie pudełko lub torbę, w której możesz trzymać swojego Raspberry Pi, klawiaturę itp. Przed każdą sesją wyjmij wszystkie części, podłącz wszystko i przejdź przez proces uruchomienia aż do momentu, gdy będziesz miał uruchomionego Sonic Pi i będziesz mógł wydawać z niego dźwięki. Kiedy skończysz ćwiczenia, poświęć odpowiednią ilość czasu na ostrożne spakowanie wszystkiego z powrotem do torby. Na początku może Ci to zajmować trochę czasu, ale po praktyce będziesz w stanie przygotować wszystko i spakować z powrotem w niewiarygodnie krótkiej chwili bez konieczności myślenia o tym, co i jak.


## Eksperymentuj Muzycznie

Gdy masz już wszystko podłączone i jesteś gotowy, aby zacząć tworzyć muzykę, możesz na początku zastanowić się nad tym, jak z tym wystartować. Jednym z problemów, który dotyka wielu ludzi, jest to, że czasami mają dobry pomysł na to, jaki rodzaj dźwięków chcieliby zacząć tworzyć, ale są sfrustrowani tym, że nie wiedzą, jak je uzyskać. Niektórzy ludzie nie wiedzą nawet, jakiego rodzaju dźwięki chcieliby tworzyć! Pierwsza rzecz to nie należy się tym przejmować - jest to bardzo popularny problem i zdarza się każdemu muzykowi - nawet jeśli ćwiczą już od wielu lat. Dużo ważniejsze jest tworzenie dźwięków, które Ci się nie podobają, aniżeli nie tworzenie żadnych dźwięków.

Wskazówka #5 - postaraj się poświęcić czas na tworzenie dźwięków i muzyki, której nie lubisz. Spróbuj wykorzystać wolną chwilę na poznawanie nowych dźwięków i pomysłów. Nie przejmuj się, że mogą brzmieć kiepsko, jeśli to nie jest styl, którego szukasz. Kiedy eksperymentujesz, w taki sposób zwiększasz szanse na to, że trafisz przypadkiem na dźwięk lub kombinacje dźwięków, które pokochasz! Nawet jeśli 99% dźwięków, które stworzysz, będzie do kitu, to ten 1% może okazać się riffem lub niezłym intro do Twojego nowego kawałka. Zapomnij o rzeczach, które Ci się nie podobają, a zapamiętaj tylko te części, które Ci leżą. Tworząc muzykę za pomocą kodu, jest to nawet łatwiejsze - wystarczy nacisnąć przycisk zapisz (Save)!


## Usłysz Kod

Wielu muzyków potrafi spojrzeć zapis nutowy i usłyszeć muzykę w ich głowach bez konieczności jej zagrania. Jest to bardzo przydatna umiejętność i warto ją włączyć do Twoich sesji praktykowania kodowania na żywo. Ważnym punktem jest tu umiejętność pewnego zrozumienia, jak dany kod będzie brzmiał. Nie musisz posiadać zdolności dokładnego słyszenia tego w Twojej głowie, zamiast tego bardzo przydatne jest posiadanie wiedzy o tym, czy ten kod będzie szybki, wolny, głośny, rytmiczny, melodyjny, losowy itp. Naszym ostatecznym celem jest umiejętność odwrócenia tego procesu - tak że gdy usłyszysz w swojej głowie muzykę, to będziesz umiał napisać kod, który będzie brzmiał tak samo. Może Ci to zająć sporo czasu, zanim opanujesz tę umiejętność, ale gdy już Ci się uda, będziesz w stanie improwizować na scenie i wyrażać biegle swoje pomysły.

Wskazówka #6 - napisz pewien kawałek kodu w Sonic Pi, ale nie naciskaj przycisku Run. Zamiast tego spróbuj wyobrazić sobie dźwięk, jaki on wyprodukuje. Następnie naciśnij przycisk Run, posłuchaj i zastanów się nad tym, czy miałeś rację, czy nie. Postaraj się to powtarzać, aż stanie się naturalną częścią Twojego procesu kodowania. Kiedy ćwiczę, zazwyczaj mam dobre rozeznanie w tym, jak będzie brzmiał dany kod. Mimo to wciąż zdarza mi się, że od czasu do czasu jestem zaskoczony i wtedy zatrzymuję się oraz spędzam chwilę czasu, aby zrozumieć, dlaczego się myliłem. Za każdym razem, gdy się to wydarzy, uczę się nowych sztuczek, które pozwalają mi na wyrażanie siebie na nowe sposoby.

## Usuń wszelkie rozpraszacze

Dość znanym problemem podczas ćwiczeń jest możliwość rozproszenia się przez inne rzeczy. Ćwiczenie jest bardzo ciężkie i wymaga samodyscypliny niezależnie od gatunku muzycznego, jaki tworzysz - od jazzu poprzez muzykę klasyczną po EDM (ang. Electronic Dance Music - elektroniczna muzyka taneczna). Jeśli borykasz się z tym, żeby zacząć lub zrobić jakiś postęp, to często zbyt łatwo jest przełączyć się na serwis społecznościowy, zacząć grzebać po internecie, itp. Jeśli ustawisz sobie za cel 20 minut ćwiczeń dziennie, bardzo ważne jest, aby spróbować spędzić cały ten czas na byciu tak bardzo produktywnym, jak tylko się da.

Wskazówka #7 - zanim zaczniesz ćwiczyć, postaraj się usunąć wszelkie rzeczy, które Cie rozpraszają. Na przykład odłącz się od internetu, wynieś telefon do innego pokoju i spróbuj ćwiczyć w cichym miejscu, gdzie nikt i nic nie będzie Cię rozpraszać. Spróbuj skupić się na kodowaniu muzyki, a do swoich rozpraszaczy możesz wrócić, kiedy skończysz.


## Prowadź dziennik ćwiczeń

Kiedy zaczniesz trenować, często zdasz sobie sprawę z tego, iż Twój umysł jest pełen wielu ekscytujących pomysłów - nowych muzycznych ścieżek, dźwięków czekających na wypróbowanie, świeżych funkcji do wpisania itd. Te myśli są na każdym kroku bardzo interesujące, przez co będziesz chciał zboczyć z wybranej ścieżki i je swobodnie wypróbować. Jest to kolejna forma rozproszenia!

Wskazówka #9 - trzymaj dziennik ćwiczeń tuż przy swojej klawiaturze. Kiedy wpadniesz na nowy ekscytujący pomysł, na chwilę przerwij swoje ćwiczenia, szybko zapisz tę ideę, a następnie zapomnij o niej i wróć do swoich ćwiczeń. Później, gdy już zakończysz ćwiczenia, możesz poświęcić odpowiednią ilość czasu, aby przemyśleć i rozwinąć swoje pomysły.


## Połączenie tego wszystkiego w jedną całość

Postaraj się zaplanować sesję, która będzie zawierała tak wiele z tych pomysłów, jak to tylko możliwe. Postaraj się, aby były one tak bardzo fajne i zabawne, ale miej na uwadze to, że część sesji będzie ciężka i będzie sprawiała wrażenie pracy. Jednakże to wszystko będzie tego warte, gdy już uda Ci się stworzyć swój pierwszy kawałek lub będziesz miał za sobą pierwszy publiczny występ. Pamiętaj, trening czyni mistrza!
