2.2 Optiuni sintetizatoare

# Optiuni sintetizatoare: Amp (amplitudine) si Pan (pozitionare)

Pe langa faptul ca permite alegerea notelor sau sample-urilor pe care le va reda, Sonic Pi ofera o gama larga de optiuni pentru modificarea sunetelor. Vom acoperi mare parte dintre acestea in tutorial si exista o documentatie bogata pentru fiecare dintre ele in sistemul de help (ajutor). Deocmandata, vom face cunostinta cu doua dintre cele mai utile: *amplitudinea (amp)* si *pozitionarea (pan)*. Pentru inceput, sa privim putin ce inseamna de fapt optiunile.


## Optiuni

Sonic Pi ofera suport pentru optiuni (sau opts - prescurtarea din engleza) pentru sintetizatoare. Optiunile sunt parametri pe care ii trasnmiti comenzii 'play' pentru a modifica si controla diferite caracteristici ale sunetului pe care il vei auzi. Fiecare sintetizator are setul sau de optiuni pentru a regla fin sunetul. Totusi, exista si seturi de optiuni comune care se aplica multor sunete, cum ar fi 'amp:' si optiunile legate de anvelopa sunetului (prezentate in alta sectiune).

Optiunile au doua componente majore, numele parametrului si valoarea acestuia. De exemplu, ai putea avea o optiune numita 'cheese:' si ai dori sa ii atribui valoarea '1'.

Optiunile sunt transmise catre comanda 'play' folosind virgula ',' si apoi numele optiunii, cum ar fi 'amp:' (nu uita ':'), apoi un spatiu si valoarea pentru optiune. De exemplu:

```
play 50, cheese: 1
```

('cheese:' nu reprezinta o optiune reala, o folosim doar ca exemplu).

Poti transmite mai multe optiuni, separandu-le prin virgula:

```
play 50, cheese: 1, beans: 0.5
```

Ordinea optiunilor nu conteaza, deci urmatoarea linie are acelasi efect:

```
play 50, beans: 0.5, cheese: 1
```

Optiunile care nu sunt recunoscute de sintetizator sunt ignorate (cum este cazul cu 'cheese' si 'beans' care sunt evident niste nume inventate!)

Daca din greseala folosesti aceeasi optiune de doua ori, cu valori diferite, ultima castiga. De exemplu, pentru 'beans:' valoarea luata in calcul va fi 2, nu 0.5:

```
play 50, beans: 0.5, cheese: 3, eggs: 0.1, beans: 2
```

Mai multe elemente din Sonic Pi accepta optiuni, deci acorda-le putina atentie si invata cum sa le folosesti, pentru ca iti va fi de folos! Sa ne jucam putin cu prima optiune: 'amp:'.

## Amplitudinea

Amplitudinea spune computerului care este taria sunetului pe care o doresti. *O amplitudine mare produce un sunet puternic*, iar *o amplitudine mica produce un sunet slab*. Asa cum Sonic Pi foloseste numere pentru a reprezenta durate si note, tot la fel foloseste numere pentru a reprezenta amplitudinea. Amplitudinea 0 inseamna liniste (nu vei auzi nimic), in timp ce amplitudineea 1 inseamna volum normal. Poti creste amplitudinea mai mult, la 2, 10, 100. Totusi, vei observa ca atunci cand amplitudinea globala a sunetelor devine prea mare, Sonic Pi foloseste un asa numit compresor pentru a le reduce si a se asigura ca nu devin prea puternice pentru urechile tale. De obicei aceasta face ca sunetele sa fie neclare si ciudate. Incearca deci sa folosesti amplitudini joase, adica in intervalul 0 - 0.5, pentru a evita compresia.


## Sa crestem amplitudinea

Pentru a schimba amplitudinea unui sunet, poti folosi optiunea 'amp:'. De exemplu, pentru a reda sunetul cu amplitudinea la jumatate, da-i valoarea 0.5:

```
play 60, amp: 0.5
```

Pentru a-l reda la amplitudine dubla, da-i valoarea 2:

```
play 60, amp: 2
```

Optiunea 'amp:' are efect doar in cadrul instructiunii 'play' din care face parte. Deci, in acest exemplu, primul play va fi cu volumul la jumatate, iar al doilea va reveni la valoarea implicita (1):

```
play 60, amp: 0.5
sleep 0.5
play 65
```

Desigur, se pot folosi valori diferite pentru 'amp:' pentru fiecare instructiune play:

```
play 50, amp: 0.1
sleep 0.25
play 55, amp: 0.2
sleep 0.25
play 57, amp: 0.4
sleep 0.25
play 62, amp: 1
```

## Pozitionare (panning)

Alta optiune interesanta este 'pan:' care controleaza pozitionarea sunetului in stereo. Pozitionarea unui catre stanga va face sa il auzi mai puternic in difuzorul din stanga, iar pozitionarea la dreapta inseamna ca il vei auzi mai puternic in difuzorul din dreapta. In Sonic Pi vom folosi -1 pentru a reprezenta un sunet care se aude doar in stanga, 0 pentru un sunet pozitionat central si 1 pentru un sunet care se aude doar in dreapta. Desigur, poti utiliza orice valoare intre -1 si 1 ca sa controlezi exact pozitia sunetului.

Sa redam un beep in difuzorul din stanga:

```
play 60, pan: -1
```

Acum, sa-l redam in difuzorul din dreapta:

```
play 60, pan: 1
```

La final sa-l redam inapoi in centru (in pozitia implicita):

```
play 60, pan: 0
```

Acum, distreaza-te schimband amplitudinea si pozitionarea sunetelor!
