2.3 Переключение между синтезаторами

# Переключаем Синтезаторы

До сего момента мы, по большей части, развлекались с простыми звуками. Однако, простые тона уже начали вас утомлять. Разве это все, что Sonic Pi может предложить? Определенно, у лайвкодинга есть больше возможностей, чем просто гудение. Да, есть. И в этой главе мы познакомимся с захватывающим набором звуков, доступных в Sonic Pi.

## Синтез

В Sonic Pi есть ряд инструментов, называемых синтами, что есть *сокращение от термина "синтезатор"*. В то время, как сэмплы представляют собой предварительно записанные звуки, синты могут генерировать новые звуки в зависимости от того, как вы ими управляете (это мы изучим далее в этом учебнике). Синты Sonic Pi - очень могущественные и яркие инструменты. Играть с ними очень весело. Вначале, давайте научимся выбирать какой синтезатор мы будем использовать.

## Жужжащие Пилы И Профеты

*Пилообразная волна* - забавный звук. Давайте попробуем его:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
play 62
sleep 0.25
```

Попробуйте другой - *prophet*:

```
use_synth :prophet
play 38
sleep 0.25
play 50
sleep 0.25
play 62
sleep 0.25
```

Как насчет смешивания обоих. Сначала один, а потом другой:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
use_synth :prophet
play 57
sleep 0.25
```

А теперь несколько звуков одновременно (без засыпания между вызовами `play`):

```
use_synth :tb303
play 38
sleep 0.25
use_synth :dsaw
play 50
sleep 0.25
use_synth :prophet
play 57
sleep 0.25
```

Как вы могли заметить, команда `use_synth` влияет только на следующие вызовы `play`. Представьте, что это *большой выключатель* - новые вызовы `play` будут играть только на используемом синте. На новый синт можно переключиться с помощью `use_synth`.


## Изучаем синтезаторы

Чтобы увидеть, какие синты есть в Sonic Pi, загляните во вкладку Synths в меню слева внизу (рядом с Fx). Там их больше 20 на выбор. Вот несколько моих любимых:

* `:prophet`
* `:dsaw`
* `:fm`
* `:tb303`
* `:pulse`

Попробуйте *попереключаться между синтами, пока ваша музыка играет*. Позабавьтесь со смешиванием синтов, чтобы получать новые звуки. Еще можно использовать разные синтезаторы для разных частей музыки.
