12.2 Envoyer du OSC

# Envoyer du OSC

En plus de recevoir du OSC et de travailler avec en utilisant l'État du Temps, nous pouvons également envoyer des messages OSC en synchronisation avec notre musique (tout comme nous pouvons envoyer des messages MIDI en synchronisation avec notre musique). Nous devons seulement savoir à quelle adresse IP et port nous envoyons. Essayons-le :

```
use_osc "localhost", 4560
osc "/hello/world"
```

Si vous exécutez le code ci-dessus, vous allez remarquer que Sonic Pi s'envoie lui-même un message OSC ! Ceci parce que nous avons configuré l'adresse IP de la machine courante et le port au port par défaut pour OSC. C'est essentiellement la même chose que de se poster une lettre à soi-même - le paquet OSC est créé, quitte Sonic Pi, se rend à la pile réseau du système d'exploitation qui va retourner le paquet à Sonic Pi et il recevra ensuite un message OSC standard qui est visible dans la queue du journal en tant que message entrant `"/osc:127.0.0.1:4560/hello/world`. (Remarquez comment Sonic Pi préfixe automatiquement tous les messages OSC entrants avec `/osc` puis le nom d'hôte et le port de l'expéditeur.)

## Envoyer du OSC à d'autres programmes

Évidemment, envoyer des messages OSC à nous-mêmes peut être amusant, mais pas très utile. Le vrai bénéfice commence quand nous envoyons des messages à d'autres programmes :


```
use_osc "localhost", 123456
osc "/hello/world"
```

Dans ce cas, nous assumons qu'il existe un autre programme sur la même machine qui écoute sur le port 123456. Si c'est le cas, il va recevoir un message OSC `"/hello/world` avec lequel il peut faire ce qu'il veut.

Si votre programme s'exécute sur une autre machine, nous avons besoin de savoir son adresse IP que nous allons utiliser au lieu de `"localhost"` :

```
use_osc "192.168.10.23", 123456
osc "/hello/world"
```

Maintenant, nous pouvons envoyer des messages OSC à n'importe quel périphérique accessible via nos réseaux locaux et même l'internet !
